#!/usr/bin/perl -w
use strict;
use IO::Socket;

my($MSG, $PORTNO, $portaddr, $HOSTNAME, $addr, $frame);

$MSG    = "?"; 				# Message to send to empeg
$PORTNO = 8300;				# Port to use

# Localhost info for binding port
my $diaddr = gethostbyname(`hostname`);
my $dpaddr = sockaddr_in ($PORTNO, $diaddr);

# Build outgoing socket
socket(SOCKET, PF_INET, SOCK_DGRAM, getprotobyname("udp")) 
    or die "socket: $!";
setsockopt(SOCKET, SOL_SOCKET, SO_BROADCAST, 1);

# Send packet
$portaddr = sockaddr_in($PORTNO, inet_aton('255.255.255.255'));
send(SOCKET, $MSG, 0, $portaddr) == length($MSG)
        or die "cannot send to $HOSTNAME($PORTNO): $!";

# Read packet
socket(SOCKET, PF_INET, SOCK_DGRAM, getprotobyname("udp"))
    or die "socket: $!";
bind (SOCKET, $dpaddr);

# Dump any incoming data
$| = 1;
while (1) {
   $addr = recv (SOCKET, $frame, 1500, 0);
	print inet_ntoa(substr($addr, 4, 4)) . ": ";
     print $frame;
}
